<script lang="ts">
	import '$lib/styles/app.css';
	import anime from 'animejs';
	import { onMount } from 'svelte';
	import { fade } from 'svelte/transition';
	import MoneyRainItem from './MoneyRainItem.svelte';

	type MoneyRainType = {
		left: string;
		top: string;
		zIndex: number;
	};
	// Этот интервал нужен чтобы менять скорость генерации монет
	// Чем меньше число, тем быстрее генерируются монеты
	export let intervalGenerate = 80;
	export let isAnimated = false;

	let coinRainWrapper: HTMLDivElement;
	let coins: MoneyRainType[] = [];
	$: if (isAnimated) coins = [{ left: '3%', top: '1.5%', zIndex: 1 }];

	function addCoind() {
		if (coins.length && isAnimated) {
			const newCoin: MoneyRainType = {
				left: `${Math.random() * 100}%`,
				top: `${Math.random() * 10}%`,
				zIndex: anime.random(0, 1)
			};
			coins = [...coins, newCoin];
		}
	}

	onMount(() => {
		const intervalLink = setInterval(addCoind, intervalGenerate);

		return () => {
			clearInterval(intervalLink);
		};
	});
</script>

<div
	class="tw-fixed tw-z-[9999] tw-w-full tw-h-screen tw-inset-0 tw-overflow-hidden tw-pointer-events-none"
	bind:this={coinRainWrapper}
	out:fade
>
	{#each coins as { left, top, zIndex }}
		<MoneyRainItem {left} {top} {zIndex} duration={3.6} durationRotateX={2.5} size={60} />
	{/each}
</div>
